import static java.util.Calendar.*
import java.net.ServerSocket

String macaddy = "001617627FDB"
Long seekmillis = 2100000 //35 minutes
def tuningsoon = false
def tuningxbox = false

def nowtime = new Date()
println "Current time " + nowtime

//sage.Airing[] GetScheduledRecordingsForDeviceForTime(java.lang.String CaptureDevice, long StartTime, long StopTime)
Global.GetScheduledRecordingsForDeviceForTime("Hauppauge HD PVR Capture Device", nowtime.time.toLong(), nowtime.time.toLong() + seekmillis).each {
	println "Hauppauge HD PVR Capture Device is recording right now or soon. Waking tuner01 and Xbox."
	tuningsoon = true
	tuningxbox = true
}

Global.GetScheduledRecordingsForDeviceForTime("Hauppauge HD PVR Capture Device #2", nowtime.time.toLong(), nowtime.time.toLong() + seekmillis).each {
	println "Hauppauge HD PVR Capture Device #2 is recording right now or soon. Waking tuner01."
	tuningsoon = true
}

if (tuningsoon) {
	WOL(macaddy) //Wake up tuner01.
	WOL(macaddy) //Wake up tuner01.
	//Wake up Xbox tuner.
	if (tuningxbox) {
		while (!WMCRunning()) {		
			Thread.sleep(100)
		}
		println "Sending ON IR command to Xbox."
		println "cmd /c \"D:\\Server\\WMCTuner\\Xbox 360\\Turn On.cmd\""
		Process pon = "cmd /c \"D:\\Server\\WMCTuner\\Xbox 360\\Turn On.cmd\"".execute()
		pon.err.eachLine { line -> println line }
		pon.in.eachLine { line -> println line }
	} else {
		println "Sending OFF IR command to Xbox."
		println "cmd /c \"D:\\Server\\WMCTuner\\Xbox 360\\Turn Off.cmd\""
		Process poff = "cmd /c \"D:\\Server\\WMCTuner\\Xbox 360\\Turn Off.cmd\"".execute()
		poff.err.eachLine { line -> println line }
		poff.in.eachLine { line -> println line }
	}
	
	return 2 //Do nothing.
}
else
{
	if (!WMCRunning()) {
		println "Nothing recording now or soon on remote tuners. Tuner01 will remain shutdown."
		return 2 //Already shutdown. Do nothing.	
	}
	
	println "Nothing recording now or soon on remote tuners. Shutting down tuner01."
	println "Sending OFF IR command to Xbox."
	Process poff = "cmd /c \"D:\\Server\\WMCTuner\\Xbox 360\\Turn Off.cmd\"".execute()
	poff.err.eachLine { line -> println line }
	poff.in.eachLine { line -> println line }
}

return 0

def WOL(String mac) {
	def int PORT = 9

	// Read MAC address
	byte[] macBytes = new byte[6]
	for (pos in 0..5) {
		macBytes[pos] = Integer.valueOf(mac.substring(pos*2,pos*2+2), 16)
	}
	
	// Construct packet data
	byte[] data = new byte[6 + 16 * 6]
	for (i in 0..5) {
		data[i] = 0xff
	}
	for (i in 1..16) {
		System.arraycopy(macBytes, 0, data, i * 6, 6)
	}
	 
	// Send packet
	InetAddress address = InetAddress.getByName("192.168.1.255")
	DatagramPacket packet = new DatagramPacket(data, data.length, address, PORT)
	DatagramSocket socket = new DatagramSocket()
	socket.send(packet)
	socket.close()
	
	println "WOL packet sent to tuner01."
}

Boolean WMCRunning()
{
	try {
		def requestSocket = new Socket("tuner01", 40400); //WMC TCP/IP Listen Port
		requestSocket.setSoTimeout(1000);
		def r = new BufferedReader(new InputStreamReader(requestSocket.getInputStream()))
		String message = r.readLine()
		r.close()
		println "WMC is running."
	} catch (Exception e) {
		println "WMC is not running."
		return false //Not running.
	}
	return true
}